﻿namespace TabsStudioSaver
{
    public class Saver : TabsStudioExt.ITabsStudioAddin
    {
        public Saver()
        {
        }

        public void OnConnection(TabsStudioExt.ITabsStudioEngine engine_, EnvDTE80.DTE2 dte)
        {
            engine = engine_;
            orderController = new OrderController(engine, dte);
            engine.TabCreated += OnTabCreated;

            solutionEventsSink = new SolutionEventsSink(orderController);
            System.IServiceProvider serviceProvider = new Microsoft.VisualStudio.Shell.ServiceProvider(
                    dte as Microsoft.VisualStudio.OLE.Interop.IServiceProvider);
            vsSolution = serviceProvider.GetService(typeof(Microsoft.VisualStudio.Shell.Interop.SVsSolution)) as
                Microsoft.VisualStudio.Shell.Interop.IVsSolution;
            vsSolution.AdviseSolutionEvents(solutionEventsSink, out sinkCookie);
        }

        public void OnDisconnection()
        {
            vsSolution.UnadviseSolutionEvents(sinkCookie);

            engine.TabCreated -= OnTabCreated;
        }

        private void OnTabCreated(object sender, TabsStudioExt.TabEventArgs e)
        {
            if (solutionEventsSink.IsSolutionOpening())
                orderController.OnTabCreated(e);
        }

        private Microsoft.VisualStudio.Shell.Interop.IVsSolution vsSolution;
        private OrderController orderController;
        private SolutionEventsSink solutionEventsSink;
        private uint sinkCookie;
        TabsStudioExt.ITabsStudioEngine engine;
    }
}
